var phidget22 = require('phidget22');

var SERVER_PORT = 5661;

function main() {

	if (process.argv.length != 3) {
		console.log('usage: node GPS.js <server address>');
		process.exit(1);
	}
	var hostname = process.argv[2];

	console.log('connecting to:' + hostname);
	var conn = new phidget22.Connection(SERVER_PORT, hostname, { name: 'Server Connection', passwd: '' });
	conn.connect()
		.then(runExample)
		.catch(function (err) {
			console.error('Error running example:', err.message);
			process.exit(1);
		});
}

function runExample() {

	console.log('connected to server');
	var ch = new phidget22.GPS();

	ch.onAttach = function (ch) {
		console.log(ch + ' attached');
	};

	ch.onDetach = function (ch) {
		console.log(ch + ' detached');
	};

	ch.onPositionChange = function (latitude, longitude, altitude) {
		console.log('latitude:' + latitude + ' (' + this.getLatitude() + ')');
		console.log('longitude:' + longitude + ' (' + this.getLongitude() + ')');
		console.log('altitude:' + altitude + ' (' + this.getAltitude() + ')');
		console.log();
	};

	ch.onHeadingChange = function (heading, velocity) {
		console.log('heading:' + heading + ' (' + this.getHeading() + ')');
		console.log('velocity:' + velocity + ' (' + this.getVelocity() + ')');
		console.log();
	};

	ch.open().then(function (ch) {
		console.log('channel open');
	}).catch(function (err) {
		console.log('failed to open the channel:' + err);
	});
}

if (require.main === module)
	main();
